[call storage="DraggableLayer.ks"]
[call storage="PieceLayer.ks"]

[iscript]
class Puzzle
{
	var horizontalBlocks; // 摜
	var verticalBlocks; // c摜
	var pieceWidth; // s[X̕
	var pieceHeight; // s[X̍
	var remainingPieces; // cĂ(ʒuɒuĂȂ)s[X̐
	var baseLayer; // wipC(Obh\邽߂̃C)
	var imageLayer; // 摜ǂݍłC
	var pieceLayers; // s[XpC̔z(Qz)
	var storageOnCompletion; // pYɃWvViIt@C
	var targetOnCompletion; // pYɃWv郉x

	// RXgN^
	function Puzzle(elm)
	{
		// wipC܂
		baseLayer = new Layer(kag, kag.fore.base);
		with(baseLayer)
		{
			.setImageSize(kag.fore.base.width, kag.fore.base.height); // 摜TCY\ʂ̔wiCƓTCYɂ܂
			.setSizeToImageSize(); // C̕\TCY摜TCYɍ킹܂
			.fillRect(0, 0, .width, .height, 0x00000000); // Ŝ𓧖FœhԂ܂
			.hitThreshold = 256; // }EXbZ[W󂯎Ȃ悤ɂ܂
			.visible = true; // \Ԃɂ܂
		}

		// 摜ǂݍł߂̃C܂
		imageLayer = new Layer(kag, baseLayer);
		imageLayer.loadImages(elm.image); // 摜ǂݍ݂܂

		// }N̑Ɏw肳Ăݒ荀ڂoϐɕۑĂ܂
		horizontalBlocks = elm.hblock !== void ? +elm.hblock : 5;
		verticalBlocks = elm.vblock !== void ? +elm.vblock : 5;
		storageOnCompletion = elm.storage !== void ? elm.storage : "";
		targetOnCompletion = elm.target !== void ? elm.target : "";


		// c^̕s[X̕EEvZ܂
		pieceWidth = imageLayer.imageWidth \ horizontalBlocks;
		pieceHeight = imageLayer.imageHeight \ verticalBlocks;
		remainingPieces = horizontalBlocks * verticalBlocks;

		// 摜̍[E[̈ʒu left, top ɃZbg܂
		var left = elm.left !== void ? +elm.left : (baseLayer.width - imageLayer.imageWidth) \ 2;
		var top = elm.top !== void ? +elm.top : (baseLayer.height - imageLayer.imageHeight) \ 2;

		// Obh̐F gridColor ɃZbg܂
		var gridColor = elm.gridcolor !== void ? +elm.gridcolor : 0xFF000000;

		pieceLayers = new Array(); // s[XpC̔z܂
		for(var y=0;y<verticalBlocks;y++)
		{
			pieceLayers[y] = new Array(); // Qz܂
			for(var x=0;x<horizontalBlocks;x++)
			{
				//  x ԖځAォ y Ԗڂ̃s[X(pieceLayers[y][x])̈ʒuvZ
				var pieceLeft = left + x * pieceWidth;
				var pieceTop = top + y * pieceHeight;
				// s[XpC܂
				pieceLayers[y][x] = new PieceLayer(kag, baseLayer, pieceLeft, pieceTop, onDragStarted, onDragFinished);
				with(pieceLayers[y][x])
				{
					.setImageSize(pieceWidth, pieceHeight); // C̉摜TCY pieceWidth~pieceHeight ɐݒ肵܂
					.setSizeToImageSize(); // C̕\TCY摜TCYɍ킹܂
					// ̃s[Xɕ\摜摜Rs[܂
					.copyRect(0, 0, imageLayer, x * pieceWidth, y * pieceHeight, pieceWidth, pieceHeight);
					// ʒu_ɐݒ肵܂
					.setPos((int)(Math.random() * (kag.fore.base.width - pieceWidth)), (int)(Math.random() * (kag.fore.base.height - pieceHeight)));
					.absolute = x + y * horizontalBlocks + 1; // dˍ킹ݒ肵܂
					.visible = true; // \Ԃɂ܂
				}
				// ̃s[X̐ʒu gridColor ɐݒ肳ĂF̘gň݂͂܂
				baseLayer.fillRect(pieceLeft, pieceTop, pieceWidth, 1, gridColor);
				baseLayer.fillRect(pieceLeft, pieceTop, 1, pieceHeight, gridColor);
				baseLayer.fillRect(pieceLeft + pieceWidth - 1, pieceTop, 1, pieceHeight, gridColor);
				baseLayer.fillRect(pieceLeft, pieceTop + pieceHeight - 1, pieceWidth, 1, gridColor);
			}
		}

		// 摜̗̈ gridColor ɐݒ肳ĂF̘gň݂͂܂
		var width = pieceWidth * horizontalBlocks;
		var height = pieceHeight * verticalBlocks;
		baseLayer.fillRect(left - 1, top - 1, width + 2, 1, gridColor);
		baseLayer.fillRect(left - 1, top - 1, 1, height + 2, gridColor);
		baseLayer.fillRect(left + width, top - 1, 1, height + 2, gridColor);
		baseLayer.fillRect(left - 1, top + height, width + 2, 1, gridColor);

		// ENbNŃMuAbvł悤ɉENbNtbNo^܂
		kag.rightClickHook.add(onGiveUp);
	}

	// fXgN^
	function finalize()
	{
		// ENbNtbN̓o^܂
		kag.rightClickHook.remove(onGiveUp);

		// ׂẴs[XpC𖳌܂
		for(var y=0;y<verticalBlocks;y++)
		{
			for(var x=0;x<horizontalBlocks;x++)
				invalidate pieceLayers[y][x];
		}
		invalidate imageLayer; // 摜ǂݍłC𖳌܂
		invalidate baseLayer; // wipC𖳌܂
	}

	// s[X̃hbOJnꂽɌĂяo郁\bh
	function onDragStarted(piece)
	{
		// hbOs[XȊÕs[X̏dˍ킹P܂
		for(var y=0;y<verticalBlocks;y++)
		{
			for(var x=0;x<horizontalBlocks;x++)
			{
				if(pieceLayers[y][x].absolute > piece.absolute)
					pieceLayers[y][x].absolute--;
			}
		}
		// hbOs[XԎOɕ\悤ɂ܂
		piece.absolute = horizontalBlocks * verticalBlocks;
	}

	// s[X̃hbOIɌĂяo郁\bh
	function onDragFinished(piece)
	{
		with(piece)
		{
			// s[X x W goalLeft}2 sNZ͈̔͂ɂāc
			if(.left >= .goalLeft - 4 && .left <= .goalLeft + 4)
			{
				// ɁAs[X y W goalTop}2 sNZ͈̔͂ɂ΁A
				// s[XʒuɒuꂽƂ݂Ȃ܂
				if(.top >= .goalTop - 4 && .top <= .goalTop + 4)
				{
					// s[X𐳂ʒuɒuāA
					.setPos(.goalLeft, .goalTop);
					// ȏ㓮Ȃ܂
					.enabled = false;
					// ʒuɒuꂽs[XȊÕs[X̏dˍ킹Pグ܂
					for(var y=0;y<verticalBlocks;y++)
					{
						for(var x=0;x<horizontalBlocks;x++)
						{
							if(pieceLayers[y][x].absolute < .absolute)
								pieceLayers[y][x].absolute++;
						}
					}
					// ʒuɒuꂽs[Xԉɕ\悤ɂ܂
					.absolute = 1;
					// c̃s[X̐P炵܂
					if(--remainingPieces == 0)
					{
						// ׂẴs[XʒuɒuꂽAw肳ꂽViI^xɃWv܂
						kag.process(storageOnCompletion, targetOnCompletion);
					}
				}
			}
		}
	}

	// s[XȊȌꏊŉENbNɌĂяo郁\bh
	function onGiveUp()
	{
		// MuAbv邩ǂmF̃_CAO{bNX\܂
		if(askYesNo("gC܂H"))
		{
			// gCꍇ̓s[XZbg܂
			for(var y=0;y<horizontalBlocks;y++)
			{
				for(var x=0;x<verticalBlocks;x++)
				{
					with(pieceLayers[y][x])
					{
						// _Ȉʒuɔzu܂
						.setPos(int (Math.random() * (kag.fore.base.width - pieceWidth)), int (Math.random() * (kag.fore.base.height - pieceHeight)));
						// dˍ킹ɖ߂܂
						.absolute = x + y * horizontalBlocks + 1;
						// 悤ɂ܂
						.enabled = true;
					}
				}
			}
			remainingPieces = horizontalBlocks * verticalBlocks;
		}
		return true; // ftHg̉ENbN͎̓s܂
	}
}
[endscript]

; puzzle }NFpYn߂܂(PuzzleNX̃IuWFNg܂)
;
; (wł鑮)
;     image : gp摜(Kw肵Ă)
;      left : Ԃ̉摜\ʒu̍[(ftHgFOiC̒)
;       top : Ԃ̉摜\ʒȕ[(ftHgFOiC̒)
;    hblock : 摜(ftHgFT)
;    vblock : 摜(ftHgFT)
;   storage : ɃWvViIt@C(ftHgF̃}NsViIt@C)
;    target : ɃWv郉x(ftHgFViIt@C̐擪)
; gridcolor : s[X̐ʒu\g̐F(0xAARRGGBB `Ŏw^ftHgF)
[macro name=puzzle]
[eval exp="kag.add(global.puzzle = new Puzzle(mp))" cond="typeof global.puzzle == 'undefined'"]
[endmacro]

; endpuzzle }NFpYI܂(PuzzleNX̃IuWFNg𖳌܂)
;
; (wł鑮)
;  Ȃ
[macro name=endpuzzle]
[eval exp="kag.remove(global.puzzle), invalidate global.puzzle, delete global.puzzle" cond="typeof(global.puzzle) != 'undefined'"]
[endmacro]

[return]
